package ec.edu.epn.seguridad.VO;


import java.io.Serializable;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;
import javax.naming.InitialContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import ec.edu.epn.seguridad.servicio.ServicioSeguridad;

public class CambioClave implements Serializable{

	private static final long serialVersionUID = 5313859176084820300L;
	private String claveAnterior;
    private String claveNueva;
    private String claveNueva2;    
	
	private ServicioSeguridad ss;
	{
		try {
			InitialContext ctx = new InitialContext();
			ss = (ServicioSeguridad) ctx.lookup("java:global/ServiciosSeguridadEPN/ServicioSeguridadBean!ec.edu.epn.seguridad.servicio.ServicioSeguridad");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	public String getClaveAnterior() {
		return claveAnterior;
	}
	public void setClaveAnterior(String claveAnterior) {
		this.claveAnterior = claveAnterior;
	}
	public String getClaveNueva() {
		return claveNueva;
	}
	public void setClaveNueva(String claveNueva) {
		this.claveNueva = claveNueva;
	}
	public String getClaveNueva2() {
		return claveNueva2;
	}
	public void setClaveNueva2(String claveNueva2) {
		this.claveNueva2 = claveNueva2;
	}
	
	public void validaClaveAnterior(FacesContext fc, UIComponent component, Object valor) throws ValidatorException {
		HttpServletRequest request = (HttpServletRequest) fc.getExternalContext().getRequest();
		HttpSession session = request.getSession();
		
		SesionUsuario su= (SesionUsuario)session.getAttribute("sesionUsuario");
		if (!ss.validarUsuarioPassword(su.getUsuario().getNombreUsuario(), (String)valor)) {
			FacesMessage e = new FacesMessage();
			e.setSeverity(FacesMessage.SEVERITY_ERROR);
			e.setSummary("Clave anterior incorrecta");
			throw new ValidatorException(e); 
		}
	}

	public void validaClave2(FacesContext fc, UIComponent component, Object valor) throws ValidatorException {		
		HttpServletRequest request = (HttpServletRequest)fc.getExternalContext().getRequest();
		String claveNueva = request.getParameter("formCambio:claveNueva");
		if (claveNueva==null || !claveNueva.equals((String)valor)) {
			FacesMessage e = new FacesMessage();
			e.setSeverity(FacesMessage.SEVERITY_ERROR);
			e.setSummary("La clave y la confirmacin no coinciden");
			throw new ValidatorException(e); 
		}		
	}

	
	public String cambiarClave(){
		FacesContext fc = FacesContext.getCurrentInstance();
		HttpServletRequest request = (HttpServletRequest) fc.getExternalContext().getRequest();
		HttpSession session = request.getSession();
		
		SesionUsuario su= (SesionUsuario)session.getAttribute("sesionUsuario");
     	ss.actualizarPassword(su.getUsuario().getNombreUsuario(), getClaveNueva());
     	
		return "principal";
	}
}
