package ec.edu.epn.seguridad.VO;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

//import javax.ejb.EJB;
import javax.faces.component.UIParameter;
import javax.faces.component.html.HtmlInputHidden;
import javax.faces.component.html.HtmlSelectManyCheckbox;
import javax.faces.event.ActionEvent;
import javax.naming.InitialContext;

import ec.edu.epn.seguridad.servicio.ServicioSeguridad;
import ec.edu.epn.seguridad.vo.Autorizacion;
import ec.edu.epn.seguridad.vo.Menu;
import ec.edu.epn.seguridad.vo.Perfil;

public class GestionAutorizacion implements Serializable{	

	private static final long serialVersionUID = 1735849069486849238L;
	private ServicioSeguridad ss;
	{
		try {
			InitialContext ctx = new InitialContext();
			ss = (ServicioSeguridad) ctx.lookup("java:global/ServiciosSeguridadEPN/ServicioSeguridadBean!ec.edu.epn.seguridad.servicio.ServicioSeguridad");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	///Ingreso de Autorizaciones
	private String perfilIn;
	private String perfilIDIn;
	private String menuIn;
	private String menuIDIn;
	private List<String> permisosIn;
	private List<Menu> menus;
	
	///Modificacion de Autorizaciones
	private List<Autorizacion> autorizaciones;
	private String autorizacionIDIn;
	private String autorizacionIDOut;
	private String permisosString;
	private HtmlSelectManyCheckbox permisosCheckbox;
 	
	//Estilos para los mensajes de Error
	private String style;
	private String styleSuccess="COLOR: #008000;";
	private String styleError="COLOR: #fc5868;";
	private String msgAdd;
	private String msgUp;

	public void guardarAutorizacion(ActionEvent event){
		HtmlInputHidden idPerfil = (HtmlInputHidden) event.getComponent().findComponent("idPerfilIn");
		Long auxIdPerfil = Long.parseLong(idPerfil.getValue().toString());
		HtmlInputHidden idMenu = (HtmlInputHidden) event.getComponent().findComponent("idMenuIn");
		Long auxIdMenu = Long.parseLong(idMenu.getValue().toString());
		String permisos = "";
		for(String per : permisosIn){
			permisos = permisos + per + " ";;
		}
		
		Perfil p = new Perfil();
		
		try{
			if(perfilIDIn.trim().equals("") || menuIDIn.trim().equals("")){
				throw new Exception();
			}else{			
			
			p = ss.buscarPerfilPorID(auxIdPerfil); 
			
			Menu m = new Menu();
			m = ss.obtenerMenuPorID(auxIdMenu);
			
			Autorizacion autorizacion = new Autorizacion();
			long id = ss.selectMaxIDAutorizacion()+1L;			
			autorizacion.setId(id);
			autorizacion.setPerfil(p);
			autorizacion.setMenu(m);
			autorizacion.setPermisos(permisos.trim().equals("") ? null : permisos.trim());
			
			ss.guardarAutorizacion(autorizacion);
			setStyle(getStyleSuccess());
			setMsgAdd("Autorizacin ingresada con xito");
			setPerfilIDIn("");
			setMenuIDIn("");
			List<String> permisosTemp = new ArrayList<String>();
			for(int i=0; i<4; i++ ){
				permisosTemp.add("");
			}
			setPermisosIn(permisosTemp);
			
		}
	
		}catch(Exception e){
			e.printStackTrace();
			setStyle(getStyleError());
			setMsgAdd("La operacin no fue completada");
		}
		
	}
	
	public void actualizarAutorizacion(ActionEvent event){
		
		HtmlInputHidden idAutorizacion = (HtmlInputHidden) event.getComponent().findComponent("idAutorizacionIn");
		Long auxIdAutorizacion = Long.parseLong(idAutorizacion.getValue().toString());
		HtmlInputHidden idPerfil = (HtmlInputHidden) event.getComponent().findComponent("idPerfilUpdate");
		Long auxIdPerfil = Long.parseLong(idPerfil.getValue().toString());
		HtmlInputHidden idMenu = (HtmlInputHidden) event.getComponent().findComponent("idMenuUpdate");
		Long auxIdMenu = Long.parseLong(idMenu.getValue().toString());
		String permisos = "";
		for(String per : permisosIn){
			permisos = permisos + per + " ";;
		}
		
		try{
			Perfil p = new Perfil();
			p = ss.buscarPerfilPorID(auxIdPerfil); 
			
			Menu m = new Menu();
			m = ss.obtenerMenuPorID(auxIdMenu);
			
			Autorizacion autorizacion = new Autorizacion();
			autorizacion = ss.buscarAutorizacionPorID(auxIdAutorizacion);
			autorizacion.setPerfil(p);
			autorizacion.setMenu(m);
			autorizacion.setPermisos(permisos);
			
			ss.actualizarAutorizacion(autorizacion);
			
			List<String> permisosList = new ArrayList<String>();
			for(int i=0; i<4; i++){
				permisosList.add(i, "");
			}
			setPermisosIn(permisosList);
			permisosCheckbox.setValue(permisos);
			
			setStyle(getStyleSuccess());
			setMsgUp("Autorizacin modificada con xito");
			
		}catch(Exception e){
			e.printStackTrace();
			setStyle(getStyleError());
			setMsgAdd("La operacin no fue completada");
		}
			
	}
	
	public void seleccionarPerfil(ActionEvent event){
		UIParameter componentNombre = (UIParameter) event.getComponent().findComponent("nombPerfil");
		String auxNombPerfil = componentNombre.getValue().toString();
		UIParameter componentID = (UIParameter) event.getComponent().findComponent("idPerfil");
		String auxIdPerfil = componentID.getValue().toString();
		setPerfilIn(auxNombPerfil);
		setPerfilIDIn(auxIdPerfil);
	}
	
	public void seleccionarMenu(ActionEvent event){
		UIParameter componentNombre = (UIParameter) event.getComponent().findComponent("nombMenu");
		String auxNombMenu = componentNombre.getValue().toString();
		UIParameter componentID = (UIParameter) event.getComponent().findComponent("idMenu");
		String auxIdMenu = componentID.getValue().toString();
		setMenuIn(auxNombMenu);
		setMenuIDIn(auxIdMenu);
	}
	
	public void seleccionarAutorizacion(ActionEvent event){

		UIParameter componentAutoNombre = (UIParameter) event.getComponent().findComponent("idAutorizacion");
		String auxIdAutorizacion = componentAutoNombre.getValue().toString();
		setAutorizacionIDIn(auxIdAutorizacion);
		setAutorizacionIDOut(auxIdAutorizacion);
		
		UIParameter componentPerfilNombre = (UIParameter) event.getComponent().findComponent("nombPerfilUpdate");
		String auxNombPerfil = componentPerfilNombre.getValue().toString();
		UIParameter componentPerfilID = (UIParameter) event.getComponent().findComponent("idPerfilSelectUpdate");
		String auxIdPerfil = componentPerfilID.getValue().toString();
		setPerfilIn(auxNombPerfil);
		setPerfilIDIn(auxIdPerfil);
		
		UIParameter componentMenuNombre = (UIParameter) event.getComponent().findComponent("nombMenuUpdate");
		String auxNombMenu = componentMenuNombre.getValue().toString();
		UIParameter componentMenuID = (UIParameter) event.getComponent().findComponent("idMenuSelectUpdate");
		String auxIdMenu = componentMenuID.getValue().toString();
		setMenuIn(auxNombMenu);
		setMenuIDIn(auxIdMenu);
		
		UIParameter componentPermisos = (UIParameter) event.getComponent().findComponent("permUpdate");
		String auxPermisos = componentPermisos.getValue().toString();
		setPermisosString(auxPermisos);
		List<String> permisos = new ArrayList<String>();
		String[] permisosArray = permisosString.split("[ ]");
		for(int i=0; i<permisosArray.length; i++){
			permisos.add(i, permisosArray[i]);			
		}
		setPermisosIn(permisos);
		permisosCheckbox.setValue(permisos);
	}
	
	public List<Menu> getMenus() {
		menus = new ArrayList<Menu>();
		menus = ss.getListaMenus();
		Collections.sort(menus, new ComparatorAdmin());
		return menus;
	}
	
	public List<Autorizacion> getAutorizaciones() {
		autorizaciones = new ArrayList<Autorizacion>();
		autorizaciones = ss.getListaAutorizaciones();
		return autorizaciones;
	}
	
	public void setMenus(List<Menu> menus) {
		this.menus = menus;
	}
	public String getPerfilIDIn() {
		return perfilIDIn;
	}
	public void setPerfilIDIn(String perfilIDIn) {
		this.perfilIDIn = perfilIDIn;
	}
	public String getMenuIDIn() {
		return menuIDIn;
	}
	public void setMenuIDIn(String menuIDIn) {
		this.menuIDIn = menuIDIn;
	}

	public String getPerfilIn() {
		return perfilIn;
	}
	public void setPerfilIn(String perfilIn) {
		this.perfilIn = perfilIn;
	}
	public String getMenuIn() {
		return menuIn;
	}
	public void setMenuIn(String menuIn) {
		this.menuIn = menuIn;
	}
	public List<String> getPermisosIn() {
		return permisosIn;
	}
	public void setPermisosIn(List<String> permisosIn) {
		this.permisosIn = permisosIn;
	}

	public void setAutorizacionIDIn(String autorizacionIDIn) {
		this.autorizacionIDIn = autorizacionIDIn;
	}

	public String getAutorizacionIDIn() {
		return autorizacionIDIn;
	}

	public void setAutorizacionIDOut(String autorizacionIDOut) {
		this.autorizacionIDOut = autorizacionIDOut;
	}

	public String getAutorizacionIDOut() {
		return autorizacionIDOut;
	}

	public void setPermisosString(String permisosString) {
		this.permisosString = permisosString;
	}

	public String getPermisosString() {
		return permisosString;
	}

	public void setAutorizaciones(List<Autorizacion> autorizaciones) {
		this.autorizaciones = autorizaciones;
	}

	public void setStyle(String style) {
		this.style = style;
	}

	public String getStyle() {
		return style;
	}

	public void setStyleSuccess(String styleSuccess) {
		this.styleSuccess = styleSuccess;
	}

	public String getStyleSuccess() {
		return styleSuccess;
	}

	public void setStyleError(String styleError) {
		this.styleError = styleError;
	}

	public String getStyleError() {
		return styleError;
	}

	public void setMsgAdd(String msgAdd) {
		this.msgAdd = msgAdd;
	}

	public String getMsgAdd() {
		return msgAdd;
	}

	public void setMsgUp(String msgUp) {
		this.msgUp = msgUp;
	}

	public String getMsgUp() {
		return msgUp;
	}

	public void setPermisosCheckbox(HtmlSelectManyCheckbox permisosCheckbox) {
		this.permisosCheckbox = permisosCheckbox;
	}

	public HtmlSelectManyCheckbox getPermisosCheckbox() {
		return permisosCheckbox;
	}
}
