package ec.edu.epn.seguridad.VO;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;


import javax.faces.application.FacesMessage;
import javax.faces.component.UIInput;
import javax.faces.component.html.HtmlInputText;
import javax.faces.component.html.HtmlOutputText;
import javax.faces.component.html.HtmlSelectOneListbox;
import javax.faces.component.html.HtmlSelectOneRadio;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.naming.InitialContext;
import javax.servlet.http.HttpServletRequest;



import ec.edu.epn.seguridad.servicio.ServicioSeguridad;
import ec.edu.epn.seguridad.vo.Aplicacion;
import ec.edu.epn.seguridad.vo.Menu;

public class GestionMenus implements Serializable{


	private static final long serialVersionUID = 1979325576485954289L;
	private ServicioSeguridad ss;
	{
		try {
			InitialContext ctx = new InitialContext();
			ss = (ServicioSeguridad) ctx.lookup("java:global/ServiciosSeguridadEPN/ServicioSeguridadBean!ec.edu.epn.seguridad.servicio.ServicioSeguridad");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	private String nomAplicacion;
	private List<SelectItem> opcionesActivo = new ArrayList<SelectItem>();
	private List<SelectItem> menusPorAplicacion;


	///Valores a usar para el ingreso de informacin
	private String nombre;
	private String descripcion;
	private String url;
	private String activo;	
	private String tipo;
	
	///Componentes para el ingreso de informacin
	private HtmlSelectOneListbox tipoMenu;
	private HtmlSelectOneListbox carpetaPadre;
	private HtmlSelectOneListbox comboBoxAplicacion;
	
	///Componentes para la actualizacion o modificacion de mens y opciones
	///Escoger el men a modificar
	private HtmlSelectOneListbox comboAplicaUpdate;
	private HtmlSelectOneListbox menuPadreUpdate;
	private HtmlSelectOneListbox opcionUpdate;
	private List<SelectItem> opcionesPorMenu;
	private List<SelectItem> listaOrdenMenuPadre;
	private List<SelectItem> listaOrdenPorMenu;
	
	///En esta lista se cargar el orden del Menu u Opciones 
	///dependiendo de si se selecciona uno u otro con el radio
	private List<SelectItem> listaOrden;
		
	private String tipoMenuString;
	private HtmlSelectOneRadio tipoMenuIn;
	///Modificar los campos de manera automtica
	private HtmlSelectOneListbox aplicacionUpdateIn;
	private HtmlOutputText aplicacionActualOut;
	private HtmlSelectOneListbox menuPadreUpdateIn;
	private String menuPadreNombre;
	private HtmlOutputText menuPadreActualOut;
	private String nombreMenu;
	private UIInput nombreMenuIn;
	private HtmlOutputText nombreMenuOut;
	private String descripcionMenu;
	private UIInput descripcionMenuIn;
	private HtmlOutputText descripcionMenuOut;
	private String urlMenu;
	private UIInput urlMenuIn;
	private HtmlOutputText urlMenuOut;
	private HtmlSelectOneListbox ordenMenuIn;
	private HtmlOutputText ordenMenuOut;
	private String estadoMenu;
	private HtmlSelectOneRadio estadoMenuIn;
	
	///Badera para saber que Componente esta haciendo el cambio
	private String componente;
	
	///Lista de Mens
	private List<Menu> listaMenusObjetos;
	
	//Estilos para los mensajes de Error
	private String style;
	private String styleSuccess="COLOR: #008000;";
	private String styleError="COLOR: #fc5868;";
	private String msgAdd;
	private String msgUp;
	
	public List<SelectItem> getMenusPorAplicacionIngreso(){
		if((String)comboBoxAplicacion.getValue()!=null ){
			nomAplicacion = (String)comboBoxAplicacion.getValue();
		}
		return getMenusPorAplicacion();
	}
	
	public List<SelectItem> getMenusPorAplicacionSeleccion(){
		if((String)comboAplicaUpdate.getValue()!=null ){
			nomAplicacion = (String)comboAplicaUpdate.getValue();
		}
		return getMenusPorAplicacion();
	}
	
	public List<SelectItem> getMenusPorAplicacionUpdate(){
		if((String)aplicacionUpdateIn.getValue()!=null ){
			nomAplicacion = (String)aplicacionUpdateIn.getValue();
		}
		List<SelectItem> temp = getMenusPorAplicacion();
		temp.add(new SelectItem(" ","Ninguno"));
		return temp;
	}
	
	public List<SelectItem> getMenusPorAplicacion() {
		menusPorAplicacion = new ArrayList<SelectItem>();

		if (nomAplicacion == null) {
			SelectItem i = new SelectItem();
			i.setValue("");
			i.setDescription("");
			i.setLabel("");
			menusPorAplicacion.add(i);
		} else {
			List<Menu> resultadoBusqueda = ss
					.consultarMenusPorAplicacion(nomAplicacion);
			
			Collections.sort(resultadoBusqueda, new ComparatorAdmin());
			
			if (resultadoBusqueda != null) {
				for (Menu m : resultadoBusqueda) {
					SelectItem i = new SelectItem();
					i.setValue(m.getId());
					i.setLabel(m.getNombre());
					i.setDescription(m.getDescripcion());
					menusPorAplicacion.add(i);
				}
			}
		}
		return menusPorAplicacion;
	}
	
	public List<SelectItem> getListaOrdenMenuPadre() {
		nomAplicacion = (String)comboAplicaUpdate.getValue()==null ? (String)aplicacionUpdateIn.getValue() :
			(String)comboAplicaUpdate.getValue();
		
		listaOrdenMenuPadre = new ArrayList<SelectItem>();
		
		try{

		String selectedMenuPadre = (String)menuPadreUpdate.getValue()==null ? " " : (String)menuPadreUpdate.getValue();
		if(selectedMenuPadre.trim().equals("")){
			throw new Exception();
		}
		Menu menuPadreT = ss.obtenerMenu(selectedMenuPadre);
		String menuPadre = menuPadreT.getMenuPadre()==null ? " " : menuPadreT.getMenuPadre().getNombre();
		ArrayList<Integer> listaOrdenIntegers = new ArrayList<Integer>();

		if (nomAplicacion == null) {
			SelectItem i = new SelectItem();
			i.setValue("");
			i.setDescription("");
			i.setLabel("");
			listaOrdenMenuPadre.add(i);
		} else {
			List<Menu> resultadoBusqueda = ss.consultarMenusConIgualPadre(nomAplicacion, menuPadre==null ? " " : menuPadre);		

			if (resultadoBusqueda != null) {
				for (Menu m : resultadoBusqueda) {
					listaOrdenIntegers.add(m.getOrden());
				}
			}
			
			Collections.sort(listaOrdenIntegers);
			
			for (Integer item : listaOrdenIntegers) {	           
	            SelectItem j = new SelectItem();
	            j.setValue(item.toString());
				j.setLabel(item.toString());
				listaOrdenMenuPadre.add(j);
	        }
		}
		
		}catch(Exception e){
			SelectItem i = new SelectItem();
			i.setValue("");
			i.setDescription("");
			i.setLabel("");
//			listaOrdenMenuPadre = new ArrayList<SelectItem>();
			listaOrdenMenuPadre.add(i);
		}
		
		return listaOrdenMenuPadre;
	}
	
	public List<SelectItem> getOpcionesPorMenu() {
		
		nomAplicacion = (String)comboAplicaUpdate.getValue()==null ? (String)aplicacionUpdateIn.getValue() :
			(String)comboAplicaUpdate.getValue();		
		String menuPadre = (String)menuPadreUpdate.getValue();
		opcionesPorMenu = new ArrayList<SelectItem>();
		listaOrdenPorMenu = new ArrayList<SelectItem>();
		ArrayList<Integer> listaOrdenIntegers = new ArrayList<Integer>();

		if (menuPadre == null) {
			SelectItem i = new SelectItem();
			i.setValue("");
			i.setDescription("");
			i.setLabel("");
			opcionesPorMenu.add(i);
			listaOrdenPorMenu.add(i);
		} else {
			List<Menu> resultadoBusqueda = ss
					.consultarOpcionesPorMenu(nomAplicacion, menuPadre );
			Collections.sort(resultadoBusqueda, new ComparatorAdmin());
			
			if (resultadoBusqueda != null) {
				for (Menu m : resultadoBusqueda) {
					SelectItem i = new SelectItem();
					i.setValue(m.getId());
					i.setLabel(m.getNombre());
					i.setDescription(m.getDescripcion());
					opcionesPorMenu.add(i);
					
					listaOrdenIntegers.add(m.getOrden());
				}
			}			
			Collections.sort(listaOrdenIntegers);
			
			for (Integer item : listaOrdenIntegers) {	           
	            SelectItem j = new SelectItem();
	            j.setValue(item.toString());
				j.setLabel(item.toString());
				listaOrdenPorMenu.add(j);
	        }
		}
		return opcionesPorMenu;
	}
	
	public List<SelectItem> getListaOrdenPorMenu(){
		nomAplicacion = (String)comboAplicaUpdate.getValue()==null ? (String)aplicacionUpdateIn.getValue() :
			(String)comboAplicaUpdate.getValue();		
		String menuPadre = (String)menuPadreUpdate.getValue()==null ? (String)menuPadreUpdateIn.getValue() :
			(String)menuPadreUpdate.getValue();		
		
		listaOrdenPorMenu = new ArrayList<SelectItem>();
		ArrayList<Integer> listaOrdenIntegers = new ArrayList<Integer>();

		if (menuPadre == null) {
			SelectItem i = new SelectItem();
			i.setValue("");
			i.setDescription("");
			i.setLabel("");
			listaOrdenPorMenu.add(i);
		} else {
			List<Menu> resultadoBusqueda = ss
					.consultarOpcionesPorMenu(nomAplicacion, menuPadre );
			if (resultadoBusqueda != null) {
				for (Menu m : resultadoBusqueda) {
					listaOrdenIntegers.add(m.getOrden());
				}
			}			
			
			Collections.sort(listaOrdenIntegers);
			
			for (Integer item : listaOrdenIntegers) {	            
	            SelectItem j = new SelectItem();
	            j.setValue(item.toString());
				j.setLabel(item.toString());
				listaOrdenPorMenu.add(j);
	        }
		}
		return listaOrdenPorMenu;
	}
	
	

	public void cargarMenusPadres(ActionEvent event) {		
		FacesContext fc = FacesContext.getCurrentInstance();
		HttpServletRequest request = (HttpServletRequest) fc
				.getExternalContext().getRequest();
		String nomAplica = request
				.getParameter("formNuevoMenu:fn_nomAplicacion");
		setNomAplicacion(nomAplica);		

	}
	
	public void setNombreAplicacion(ValueChangeEvent event){		
		if(event.getNewValue()!=null){
		setNomAplicacion((String)event.getNewValue());
		componente = event.getComponent().getId();
		if(componente.equals("fn_nomAplicacion")){
			comboBoxAplicacion.setValue(nomAplicacion);
		}if(componente.equals("nomAplicacionUpdate")){
			comboAplicaUpdate.setValue(nomAplicacion);
		}if(componente.equals("aplicacionUpdateIn")){
			aplicacionUpdateIn.setValue(nomAplicacion);
		}
		}
		
//		if(event.getComponent().getId().contains("aplicacionUpdateIn")
//			|| event.getComponent().getId().contains("menuPadreUpdateIn")){
//			ordenMenuIn.setDisabled(true);
//		}
//		if(event.getComponent().getId().contains("nomAplicacionUpdate")
//				|| event.getComponent().getId().contains("listaMenuPadres") 
//				|| event.getComponent().getId().contains("listaMenuOpciones")){
//				ordenMenuIn.setDisabled(false);
//		}
	}
	
	public void setMenuPadreUpdateM(ValueChangeEvent event){
		if(event.getNewValue()!=null){
			setMenuPadreNombre((String)event.getNewValue());
			menuPadreUpdateIn.setValue(menuPadreNombre);			
		}
	}
	
	public void setNombreM(ValueChangeEvent event){
		if(event.getNewValue()!=null){
			setNombreMenu((String)event.getNewValue());
			nombreMenuIn.setValue(nombreMenu);
		}
		
	}
	
	public void setDescripcionM(ValueChangeEvent event){
		if(event.getNewValue()!=null){
		setDescripcionMenu((String)event.getNewValue());
		descripcionMenuIn.setValue(descripcionMenu);
		}
	}

	public void setUrlM(ValueChangeEvent event){
		if(event.getNewValue()!=null){
		setUrlMenu((String)event.getNewValue());
		urlMenuIn.setValue(urlMenu);
		}
	}
	
	public void setOrdenMenuM(ValueChangeEvent event){
		if(event.getNewValue()!=null){
			ordenMenuIn.setValue(Integer.parseInt((String)event.getNewValue()));
		}
	}

	public void setEstadoM(ValueChangeEvent event){		
		if(event.getNewValue()!=null){
		setEstadoMenu((String)event.getNewValue());
		estadoMenuIn.setValue(estadoMenu);
		}
	}
	

	public void guardarMenu(ActionEvent event) {	
		Menu m = new Menu();
		try{
			if(nombre.trim().equals("") || descripcion.trim().equals("") ||
					activo.trim().equals("") || tipo.trim().equals("") || 
					((String)comboBoxAplicacion.getValue()).equals("")){
				throw new Exception();
			}else{
				long id = ss.selectMaxIDMenu()+1L;				
				m.setId(id);
				m.setNombre(nombre.trim());
				if(url.trim().equals("")){
					m.setUrl(null);	
				}else{
					m.setUrl(url.trim());	
				}
				m.setDescripcion(descripcion.trim());
				m.setActivo(activo.trim());
				m.setTipo(tipo.trim());			
				
				Menu menuPadresito = new Menu();
				String carpPadre = (String)carpetaPadre.getValue();
				if(!carpPadre.equals("")){
					menuPadresito = ss.obtenerMenu((String)carpetaPadre.getValue());					
					m.setMenuPadre(menuPadresito);	
				}
				
				long idAplicacion = 0L;
				List<Aplicacion> aplicaciones = ss.consultarAplicaciones();
				Aplicacion appMenu = new Aplicacion();
				for(Aplicacion app : aplicaciones){
					if(app.getNombre().equals((String)comboBoxAplicacion.getValue())){
						idAplicacion=app.getId();
						appMenu = app;						
						break;
					}
				}
				m.setAplicacion(appMenu);
				long idMenuPadre;
				idMenuPadre = menuPadresito.getId();
				
				int maxOrder = ss.getMaxMenuOrdenByMenuPadreAndAplicacion(idMenuPadre, idAplicacion);				
				m.setOrden(maxOrder+1);				
				ss.guardarMenu(m);
				setStyle(getStyleSuccess());
				setMsgAdd("Men ingresado con xito");
			}
			
		}catch(Exception e){			
			setStyle(getStyleError());
			setMsgAdd("La operacin no fue completada");
		}

	}
	
	public void actualizarMenu(ActionEvent event){
		try{			
			FacesContext fct = FacesContext.getCurrentInstance();
			HttpServletRequest request = (HttpServletRequest) fct
					.getExternalContext().getRequest();
			String nomAplica = request
					.getParameter("menuUpdate:aplicacionUpdateIn");
			setNomAplicacion(nomAplica);
			if(nomAplicacion.trim().equals("") || ((String)nombreMenuIn.getValue()).trim().equals("") ||
					((String)descripcionMenuIn.getValue()).trim().equals("") || 
					((Integer) ordenMenuIn.getValue())==null || ((String)estadoMenuIn.getValue()).equals("")){
				throw new Exception();
			}else{
				
				tipoMenuString = (String)tipoMenuIn.getValue();
				if(tipoMenuString.equals("opcion")){
					Menu m = new Menu();

					m = ss.obtenerMenu((String)opcionUpdate.getValue());					
					if(!m.getAplicacion().getNombre().equals(nomAplicacion)){
						FacesContext fc = FacesContext.getCurrentInstance();						
						if(m.getMenuPadre().getNombre().equals((String)menuPadreUpdateIn.getValue())){
							fc.addMessage("menuPadreUpdateIn", new FacesMessage(FacesMessage.SEVERITY_INFO,
									"Debe elegir un menu padre distinto",null));
							fc.addMessage("ordenMenuIn", new FacesMessage(FacesMessage.SEVERITY_INFO,
									"El orden se seleccionar automticamente",null));
							return;
						}else{
							fc.addMessage("ordenMenuIn", new FacesMessage(FacesMessage.SEVERITY_INFO,
									"El orden se seleccionar automticamente",null));
							//////GUARDAR MENUS CON ORDEN ELEGIDO AUTOMATICAMENTE///////							
							actualizarMenuOrden(m,"auto",event);
							setStyle(getStyleSuccess());
							setMsgUp("Men actualizado con xito");
						}
						return;
					}else if(m.getAplicacion().getNombre().equals(nomAplicacion)){
						FacesContext fc = FacesContext.getCurrentInstance();						
						if(m.getMenuPadre().getNombre().equals(menuPadreUpdateIn.getValue())){							
							if(m.getOrden() != (Integer) ordenMenuIn.getValue()){
								//////GUARDAR MENUS CON ORDEN ELEGIDO POR EL USUARIO///////								
								actualizarMenuOrden(m,"user",event);
								setStyle(getStyleSuccess());
								setMsgUp("Men actualizado con xito");
							}else{								
								actualizarMenuOrden(m,"ninguno",event);
								setStyle(getStyleSuccess());
								setMsgUp("Men actualizado con xito");
							}
						}else{
							fc.addMessage("ordenMenuIn", new FacesMessage(FacesMessage.SEVERITY_INFO,
									"El orden se seleccionar automticamente",null));
							//////GUARDAR MENUS CON ORDEN ELEGIDO AUTOMATICAMENTE///////							
							actualizarMenuOrden(m,"auto",event);
							setStyle(getStyleSuccess());
							setMsgUp("Men actualizado con xito");
						}
						return;
					}
				}
				
				if(tipoMenuString.equals("menu")){
					Menu m = new Menu();
					m = ss.obtenerMenu((String)menuPadreUpdate.getValue());					
					
					if(!m.getAplicacion().getNombre().equals(nomAplicacion)){
						FacesContext fc = FacesContext.getCurrentInstance();
						fc.addMessage("ordenMenuIn", new FacesMessage(FacesMessage.SEVERITY_INFO,
								"El orden se seleccionar automticamente",null));
						//////GUARDAR MENUS CON ORDEN ELEGIDO AUTOMATICAMENTE///////						
						actualizarMenuOrden(m,"auto",event);
						setStyle(getStyleSuccess());
						setMsgUp("Men actualizado con xito");
						return;
					}
					if(m.getAplicacion().getNombre().equals(nomAplicacion)){
						FacesContext fc = FacesContext.getCurrentInstance();
						String menuPadre = (String)menuPadreUpdateIn.getValue()==null ? "" : (String)menuPadreUpdateIn.getValue();
						if(menuPadre.trim().equals("")){
							if(m.getOrden() != (Integer) ordenMenuIn.getValue()){
								//////GUARDAR MENUS CON ORDEN ELEGIDO POR EL USUARIO///////								
								actualizarMenuOrden(m,"user",event);
								setStyle(getStyleSuccess());
								setMsgUp("Men actualizado con xito");
							}else{								
								actualizarMenuOrden(m,"ninguno",event);
								setStyle(getStyleSuccess());
								setMsgUp("Men actualizado con xito");
							}
							return;
						} 
						String menuPadreBase = m.getMenuPadre()==null ? "" : m.getMenuPadre().getNombre();
						if(menuPadreBase.equals(menuPadreUpdateIn.getValue())){							
							if(m.getOrden() != (Integer) ordenMenuIn.getValue()){
								//////GUARDAR MENUS CON ORDEN ELEGIDO POR EL USUARIO///////								
								actualizarMenuOrden(m,"user",event);
								setStyle(getStyleSuccess());
								setMsgUp("Men actualizado con xito");
							}else{								
								actualizarMenuOrden(m,"ninguno",event);
								setStyle(getStyleSuccess());
								setMsgUp("Men actualizado con xito");
							}
							return;
						}else{
							fc.addMessage("ordenMenuIn", new FacesMessage(FacesMessage.SEVERITY_INFO,
									"El orden se seleccionar automticamente",null));
							//////GUARDAR MENUS CON ORDEN ELEGIDO AUTOMATICAMENTE///////							
							actualizarMenuOrden(m,"auto",event);
							setStyle(getStyleSuccess());
							setMsgUp("Men actualizado con xito");
							return;
					}
					
				  }
					
				}

			}

		}catch(Exception e){
			e.printStackTrace();
			setStyle(getStyleError());
			setMsgUp("La operacin no fue completada");
		}
				
	}
	
	public void actualizarMenuOrden(Menu m, String ordenAutomatico, ActionEvent event){
//		m.setNombre(nombreMenu);
//		m.setUrl(urlMenu);
//		m.setDescripcion(descripcionMenu);
//		m.setActivo(estadoMenu);
		
		m.setNombre(((String)nombreMenuIn.getValue()).trim());
		String url = ((String)urlMenuIn.getValue())==null ? "" : ((String)urlMenuIn.getValue()).trim();
		if(url.equals("")){
			m.setUrl(null);
		}else{
			m.setUrl(url);
		}
		m.setDescripcion(((String)descripcionMenuIn.getValue()).trim());
		m.setActivo((String)estadoMenuIn.getValue());
		
		Menu menuPadresito = new Menu();
		String carpPadre = (String)menuPadreUpdateIn.getValue()==null ? "" : 
			(((String)menuPadreUpdateIn.getValue()).equals("Ninguno") ? "" : (String)menuPadreUpdateIn.getValue());
		if(!carpPadre.trim().equals("")){			
			menuPadresito = ss.obtenerMenu((String)menuPadreUpdateIn.getValue());			
		}	
		
		long idAplicacion = 0L;
		List<Aplicacion> aplicaciones = ss.consultarAplicaciones();
		Aplicacion appMenu = new Aplicacion();
		for(Aplicacion app : aplicaciones){
			if(app.getNombre().equals(nomAplicacion)){
				idAplicacion=app.getId();
				appMenu = app;				
				break;
			}
		}
		
		///Debo hacer antes de setear la nueva aplicacion y el menu padre
		long idMenuPadre;
		idMenuPadre = menuPadresito.getId();	
		
		int maxOrder = 0;
		
		tipoMenuString = (String)tipoMenuIn.getValue();
		if(tipoMenuString.equals("opcion")){
			idMenuPadre = menuPadresito.getId();			
			maxOrder = ss.getMaxMenuOrdenByMenuPadreAndAplicacion(idMenuPadre, idAplicacion);			
		}
		if(tipoMenuString.equals("menu")){
			maxOrder = ss.getMaxMenuOrdenByMenuPadreAndAplicacion(idMenuPadre, idAplicacion);			
		}

		if(!carpPadre.trim().equals("")){
			m.setMenuPadre(menuPadresito);
		}else{
			m.setMenuPadre(null);
		}
		m.setAplicacion(appMenu);		
		
		if(ordenAutomatico.equals("auto")){	
			m.setOrden(maxOrder+1);
		}if(ordenAutomatico.equals("user")){
				m.setOrden((Integer)ordenMenuIn.getValue());
		}if(ordenAutomatico.equals("ninguno")){
			
		}		
		ss.actualizarMenu(m);
		limpiarComponentesMenusTotal(event);
	
	}

	public List<SelectItem> getOpcionesActivo() {
		SelectItem i = new SelectItem();
		i.setValue("SI");
		i.setLabel("Si");

		opcionesActivo.add(i);

		SelectItem j = new SelectItem();
		j.setValue("NO");
		j.setLabel("No");

		opcionesActivo.add(j);

		return opcionesActivo;
	}
	
	public void cargarModificarMenu(ValueChangeEvent event){		
		
		tipoMenuString = (String)event.getNewValue()==null ? " " : (String)event.getNewValue();		
		setNomAplicacion(((String)comboAplicaUpdate.getValue()==null ? (String)aplicacionUpdateIn.getValue() :
			(String)comboAplicaUpdate.getValue()));		
		
		
		limpiarComponentesMenus(new ActionEvent(event.getComponent()));
		
		if(tipoMenuString.equals("opcion")){
			
			try{
				Menu m = ss.obtenerMenu((String)opcionUpdate.getValue());
				
				aplicacionUpdateIn.setValue(m.getAplicacion().getNombre());
				aplicacionActualOut.setValue("Actual: " + m.getAplicacion().getNombre());
				menuPadreUpdateIn.setValue(m.getMenuPadre().getNombre());
				menuPadreActualOut.setValue("Actual: " + m.getMenuPadre().getNombre());
				nombreMenuIn.setValue(m.getNombre());
				nombreMenuOut.setValue("Actual: " + m.getNombre());
				descripcionMenuIn.setValue(m.getDescripcion());
				descripcionMenuOut.setValue("Actual: " + m.getDescripcion());
				HtmlInputText urlIn = (HtmlInputText)urlMenuIn;
				urlIn.setDisabled(false);
				urlMenuIn.setValue(m.getUrl());
				urlMenuOut.setValue("Actual: " + m.getUrl());
				ordenMenuIn.setValue(m.getOrden());
				ordenMenuOut.setValue("Actual: " + m.getOrden());
				String activo = m.getActivo();				
				setEstadoMenu(activo);
				estadoMenuIn.setValue(activo);
			} catch (Exception e){
				System.out.println("No entity found for query");
			}
			
		}
		
		if(tipoMenuString.equals("menu")){		
			try{
				Menu m = ss.obtenerMenu((String)menuPadreUpdate.getValue());
				
				aplicacionUpdateIn.setValue(m.getAplicacion().getNombre());
				aplicacionActualOut.setValue("Actual: " + m.getAplicacion().getNombre());
				String menuPadreNombre = m.getMenuPadre()==null ? " " : m.getMenuPadre().getNombre();
				menuPadreUpdateIn.setValue(menuPadreNombre);
				menuPadreActualOut.setValue("Actual: " + menuPadreNombre);
				nombreMenuIn.setValue(m.getNombre());
				nombreMenuOut.setValue("Actual: " + m.getNombre());
				descripcionMenuIn.setValue(m.getDescripcion());
				descripcionMenuOut.setValue("Actual: " + m.getDescripcion());
				HtmlInputText urlIn = (HtmlInputText)urlMenuIn;
				urlIn.setDisabled(false);
				urlMenuIn.setValue(m.getUrl());
				urlMenuOut.setValue("Actual: " + m.getUrl());
				ordenMenuIn.setValue(m.getOrden());
				ordenMenuOut.setValue("Actual: " + m.getOrden());
				String activo = m.getActivo();				
				setEstadoMenu(activo);
				estadoMenuIn.setValue(activo);
			}catch (Exception e){
				System.out.println("No entity found for query");
			}
			
		}
	}
	
	public void limpiarComponentesMenus(ActionEvent event){
		aplicacionUpdateIn.setValue(" ");
		aplicacionActualOut.setValue(" ");
		menuPadreUpdateIn.setValue(" ");
		menuPadreActualOut.setValue(" ");
		nombreMenuIn.setValue(" ");
		nombreMenuOut.setValue(" ");
		descripcionMenuIn.setValue(" ");
		descripcionMenuOut.setValue(" ");
		urlMenuIn.setValue(" ");
		urlMenuOut.setValue(" ");
		ordenMenuIn.setValue(" ");
		ordenMenuOut.setValue(" ");
		estadoMenuIn.setValue(" ");
	}
	
	public void limpiarComponentesMenusTotal(ActionEvent event){
		comboAplicaUpdate.setValue(" ");
		menuPadreUpdate.setValue(" ");
		opcionUpdate.setValue(" ");
		tipoMenuIn.setValue("");
		limpiarComponentesMenus(event);
	}
	
	public void setOpcionesActivo(List<SelectItem> opcionesActivo) {
		this.opcionesActivo = opcionesActivo;
	}
	
	public HtmlSelectOneListbox getComboAplicaUpdate() {
		return comboAplicaUpdate;
	}

	public void setComboAplicaUpdate(HtmlSelectOneListbox comboAplicaUpdate) {
		this.comboAplicaUpdate = comboAplicaUpdate;
	}

	public HtmlSelectOneListbox getMenuPadreUpdate() {
		return menuPadreUpdate;
	}

	public void setMenuPadreUpdate(HtmlSelectOneListbox menuPadreUpdate) {
		this.menuPadreUpdate = menuPadreUpdate;
	}

	public HtmlSelectOneListbox getOpcionUpdate() {
		return opcionUpdate;
	}

	public void setOpcionUpdate(HtmlSelectOneListbox opcionUpdate) {
		this.opcionUpdate = opcionUpdate;
	}

	public HtmlSelectOneListbox getTipoMenu() {
		return tipoMenu;
	}

	public void setTipoMenu(HtmlSelectOneListbox tipoMenu) {
		this.tipoMenu = tipoMenu;
	}

	public HtmlSelectOneListbox getCarpetaPadre() {
		return carpetaPadre;
	}
		
	public HtmlSelectOneListbox getComboBoxAplicacion() {
		return comboBoxAplicacion;
	}

	public void setComboBoxAplicacion(HtmlSelectOneListbox comboBoxAplicacion) {
		this.comboBoxAplicacion = comboBoxAplicacion;
	}

	public void setCarpetaPadre(HtmlSelectOneListbox carpetaPadre) {
		this.carpetaPadre = carpetaPadre;
	}

	public String getTipo() {
		return tipo;
	}

	public void setTipo(String tipo) {
		this.tipo = tipo;
	}

		
	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getDescripcion() {
		return descripcion;
	}

	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getActivo() {
		return activo;
	}

	public void setActivo(String activo) {
		this.activo = activo;
	}

	public String getNomAplicacion() {
		return nomAplicacion;
	}

	public void setNomAplicacion(String nomAplicacion) {
		this.nomAplicacion = nomAplicacion;
	}
	
	public void setMenusPorAplicacion(List<SelectItem> menusPorAplicacion) {
		this.menusPorAplicacion = menusPorAplicacion;
	}

		
	///////////////////////////Nuevos////////////////////////////////////
	public String getTipoMenuString() {
		return tipoMenuString;
	}

	public void setTipoMenuString(String tipoMenuString) {
		this.tipoMenuString = tipoMenuString;
	}

	public HtmlSelectOneRadio getTipoMenuIn() {
		return tipoMenuIn;
	}

	public void setTipoMenuIn(HtmlSelectOneRadio tipoMenuIn) {
		this.tipoMenuIn = tipoMenuIn;
	}

	public HtmlSelectOneListbox getAplicacionUpdateIn() {
		return aplicacionUpdateIn;
	}

	public void setAplicacionUpdateIn(HtmlSelectOneListbox aplicacionUpdateIn) {
		this.aplicacionUpdateIn = aplicacionUpdateIn;
	}

	public HtmlSelectOneListbox getMenuPadreUpdateIn() {
		return menuPadreUpdateIn;
	}

	public void setMenuPadreUpdateIn(HtmlSelectOneListbox menuPadreUpdateIn) {
		this.menuPadreUpdateIn = menuPadreUpdateIn;
	}

	public String getNombreMenu() {
		return nombreMenu;
	}

	public void setNombreMenu(String nombreMenu) {
		this.nombreMenu = nombreMenu;
	}

	public UIInput getNombreMenuIn() {
		return nombreMenuIn;
	}

	public void setNombreMenuIn(UIInput nombreMenuIn) {
		this.nombreMenuIn = nombreMenuIn;
	}

	public HtmlOutputText getNombreMenuOut() {
		return nombreMenuOut;
	}

	public void setNombreMenuOut(HtmlOutputText nombreMenuOut) {
		this.nombreMenuOut = nombreMenuOut;
	}

	public String getDescripcionMenu() {
		return descripcionMenu;
	}

	public void setDescripcionMenu(String descripcionMenu) {
		this.descripcionMenu = descripcionMenu;
	}

	public UIInput getDescripcionMenuIn() {
		return descripcionMenuIn;
	}

	public void setDescripcionMenuIn(UIInput descripcionMenuIn) {
		this.descripcionMenuIn = descripcionMenuIn;
	}

	public HtmlOutputText getDescripcionMenuOut() {
		return descripcionMenuOut;
	}

	public void setDescripcionMenuOut(HtmlOutputText descripcionMenuOut) {
		this.descripcionMenuOut = descripcionMenuOut;
	}

	public String getUrlMenu() {
		return urlMenu;
	}

	public void setUrlMenu(String urlMenu) {
		this.urlMenu = urlMenu;
	}

	public UIInput getUrlMenuIn() {
		return urlMenuIn;
	}

	public void setUrlMenuIn(UIInput urlMenuIn) {
		this.urlMenuIn = urlMenuIn;
	}

	public HtmlOutputText getUrlMenuOut() {
		return urlMenuOut;
	}

	public void setUrlMenuOut(HtmlOutputText urlMenuOut) {
		this.urlMenuOut = urlMenuOut;
	}

	public HtmlSelectOneListbox getOrdenMenuIn() {
		return ordenMenuIn;
	}

	public void setOrdenMenuIn(HtmlSelectOneListbox ordenMenuIn) {
		this.ordenMenuIn = ordenMenuIn;
	}

	public String getEstadoMenu() {
		return estadoMenu;
	}

	public void setEstadoMenu(String estadoMenu) {
		this.estadoMenu = estadoMenu;
	}

	public HtmlSelectOneRadio getEstadoMenuIn() {
		return estadoMenuIn;
	}

	public void setEstadoMenuIn(HtmlSelectOneRadio estadoMenuIn) {
		this.estadoMenuIn = estadoMenuIn;
	}
	
	public HtmlOutputText getAplicacionActualOut() {
		return aplicacionActualOut;
	}

	public void setAplicacionActualOut(HtmlOutputText aplicacionActualOut) {
		this.aplicacionActualOut = aplicacionActualOut;
	}

	public HtmlOutputText getMenuPadreActualOut() {
		return menuPadreActualOut;
	}

	public void setMenuPadreActualOut(HtmlOutputText menuPadreActualOut) {
		this.menuPadreActualOut = menuPadreActualOut;
	}

	public void setListaOrdenPorMenu(List<SelectItem> listaOrdenPorMenu) {
		this.listaOrdenPorMenu = listaOrdenPorMenu;
	}

	
	public void setOrdenMenuOut(HtmlOutputText ordenMenuOut) {
		this.ordenMenuOut = ordenMenuOut;
	}

	public HtmlOutputText getOrdenMenuOut() {
		return ordenMenuOut;
	}

	public void setListaOrdenMenuPadre(List<SelectItem> listaOrdenMenuPadre) {
		this.listaOrdenMenuPadre = listaOrdenMenuPadre;
	}

	public List<SelectItem> getListaOrden() {
		listaOrden = new ArrayList<SelectItem>();		
		
		if(((String)menuPadreUpdate.getValue())==null && ((String)opcionUpdate.getValue())==null  
				&& tipoMenuIn.getValue()==null){
			listaOrden.add(new SelectItem(" "," "));
			return listaOrden;
		}
		if(((String)menuPadreUpdate.getValue())==null && ((String)opcionUpdate.getValue())==null  
				&& tipoMenuIn.getValue()!=null){
			listaOrden.add(new SelectItem(" "," "));
			return listaOrden;
		}
		if(!((String)menuPadreUpdate.getValue()).isEmpty() && ((String)opcionUpdate.getValue())==null
				&& tipoMenuIn.getValue()==null){
			listaOrden.add(new SelectItem(" "," "));
			return listaOrden;
		}
		if(!((String)menuPadreUpdate.getValue()).isEmpty() && ((String)opcionUpdate.getValue())==null///
				&& tipoMenuIn.getValue()!=null){
			setListaOrden(getListaOrdenMenuPadre());
			return listaOrden;
		}
		if(!((String)menuPadreUpdate.getValue()).isEmpty() && !((String)opcionUpdate.getValue()).isEmpty()
				 && tipoMenuIn.getValue()==null){
			listaOrden.add(new SelectItem(" "," "));
			return listaOrden;
		}
		if(!((String)menuPadreUpdate.getValue()).isEmpty() && tipoMenuIn.getValue()==null){
			setListaOrden(getListaOrdenMenuPadre());
			return listaOrden;
		}
		if(!((String)opcionUpdate.getValue()).isEmpty() && tipoMenuIn.getValue()==null){
			setListaOrden(getListaOrdenPorMenu());
			return listaOrden;
		}
		try{
			if(tipoMenuIn.getValue().equals("menu")){
				setListaOrden(getListaOrdenMenuPadre());
				return listaOrden;
			}
			if(tipoMenuIn.getValue().equals("opcion")){
				setListaOrden(getListaOrdenPorMenu());
				return listaOrden;
			}
		}catch(Exception e){
			e.printStackTrace();
			listaOrden.add(new SelectItem(" "," "));
		}
		
		return listaOrden;
	}
	
	public List<Menu> getListaMenusObjetos() {
		listaMenusObjetos = new ArrayList<Menu>();
		listaMenusObjetos = ss.getListaMenus();
		Collections.sort(listaMenusObjetos, new ComparatorAdmin());
		return listaMenusObjetos;
	}
	
	public void setListaOrden(List<SelectItem> listaOrden) {
		this.listaOrden = listaOrden;
	}

	public void setOpcionesPorMenu(List<SelectItem> opcionesPorMenu) {
		this.opcionesPorMenu = opcionesPorMenu;
	}


	/////DEPRECATED///////
	public Menu getObtenerMenu() {		
		Menu m = new Menu();

		// para traer el objeto Aplicacion
		Aplicacion apli = new Aplicacion();
		apli = ss.obtenerAplicacion(nomAplicacion);		
		m.setAplicacion(apli);

		// Para traer el objeto MenuPadre
		FacesContext fc = FacesContext.getCurrentInstance();
		HttpServletRequest request = (HttpServletRequest) fc
				.getExternalContext().getRequest();
		String nomMenuPadre = request.getParameter("formNuevoMenu:fn_listaMenuPadres");		

		Menu menuPadresito = new Menu();
		menuPadresito = ss.obtenerMenu(nomMenuPadre);
		m.setMenuPadre(menuPadresito);
		m.setOrden(1);
		return m;
	}
///////////////////////////////////////////////////////////////////////////////
	
	
	public void setMenuPadreNombre(String menuPadreNombre) {
		this.menuPadreNombre = menuPadreNombre;
	}

	public String getMenuPadreNombre() {
		return menuPadreNombre;
	}

	public void setComponente(String componente) {
		this.componente = componente;
	}

	public String getComponente() {
		return componente;
	}
	


	public void setListaMenusObjetos(List<Menu> listaMenusObjetos) {
		this.listaMenusObjetos = listaMenusObjetos;
	}

	public void setStyle(String style) {
		this.style = style;
	}

	public String getStyle() {
		return style;
	}

	public void setStyleSuccess(String styleSuccess) {
		this.styleSuccess = styleSuccess;
	}

	public String getStyleSuccess() {
		return styleSuccess;
	}

	public void setStyleError(String styleError) {
		this.styleError = styleError;
	}

	public String getStyleError() {
		return styleError;
	}

	public void setMsgAdd(String msgAdd) {
		this.msgAdd = msgAdd;
	}

	public String getMsgAdd() {
		return msgAdd;
	}

	public void setMsgUp(String msgUp) {
		this.msgUp = msgUp;
	}

	public String getMsgUp() {
		return msgUp;
	}


}
