package ec.edu.epn.seguridad.VO;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

//import javax.ejb.EJB;
import javax.faces.component.UIInput;
import javax.faces.component.html.HtmlOutputText;
import javax.faces.component.html.HtmlSelectOneRadio;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.naming.InitialContext;
import javax.servlet.http.HttpServletRequest;

import ec.edu.epn.seguridad.servicio.ServicioSeguridad;
import ec.edu.epn.seguridad.vo.Perfil;

public class GestionPerfil implements Serializable {
	
	private static final long serialVersionUID = -1412226353696522505L;
	private ServicioSeguridad ss;
	{
		try {
			InitialContext ctx = new InitialContext();
			ss = (ServicioSeguridad) ctx.lookup("java:global/ServiciosSeguridadEPN/ServicioSeguridadBean!ec.edu.epn.seguridad.servicio.ServicioSeguridad");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	private String nombre;
	private String descripcion;
	private String activo;
	
	///COMPONENES PARA LA ACTUALIZACION///
	private UIInput inNombre;
	private HtmlOutputText outNombre;
	private UIInput inDescripcion;
	private HtmlOutputText outDescripcion;
	private HtmlSelectOneRadio inActivo;
	
	private List<SelectItem> listaPerfil;
	private List<Perfil> perfilesObjetos;
	
	//Estilos para los mensajes de Error
	private String style;
	private String styleSuccess="COLOR: #008000;";
	private String styleError="COLOR: #fc5868;";
	private String msgAdd;
	private String msgUp;
	
	
	public List<SelectItem> getListaPerfil() {
		
		listaPerfil = new ArrayList<SelectItem>();
		
		List<Perfil> buscarPerfiles = ss.buscarPerfiles();
		Collections.sort(buscarPerfiles, new ComparatorAdmin());
		
		for(Perfil p : buscarPerfiles){
			SelectItem item = new SelectItem(p.getNombre(),p.getNombre());
			listaPerfil.add(item);
		}
		
		return listaPerfil;
	}
	
	public List<Perfil> getPerfilesObjetos() {
		perfilesObjetos = new ArrayList<Perfil>();
		
		perfilesObjetos = ss.buscarPerfiles();
		
		Collections.sort(perfilesObjetos, new ComparatorAdmin());
		
		return perfilesObjetos;
	}
	
	
	public void guardarPerfil(ActionEvent event){
		Perfil p = new Perfil();
		
		try{
			if(nombre.trim().equals("") || descripcion.trim().equals("") || activo.trim().equals("")){
				throw new Exception();
			}else{
				p.setNombre(nombre.trim());
				p.setDescripcion(descripcion.trim());
				p.setActivo(activo==null ? "SI": activo.trim());
				ss.guardarPerfil(p);
				setStyle(getStyleSuccess());
				setMsgAdd("Perfil ingresado con xito");
				setNombre("");
				setDescripcion("");
				setActivo("");
			}
		}catch(Exception e){
			setStyle(getStyleError());
			setMsgAdd("La operacin no fue completada");
		}
		
	}
	
	public void actualizarPerfil(ActionEvent event){
		Perfil p = new Perfil();
		
		FacesContext fc = FacesContext.getCurrentInstance();
		HttpServletRequest request = (HttpServletRequest) fc
				.getExternalContext().getRequest();
		String nomAplica = request
				.getParameter("formActualizarPerfil:updatePerfil");
		
		try{
			p = ss.buscarPerfilPorNombre(nomAplica);
		
			if(nombre.trim().equals("") || descripcion.trim().equals("") || activo.trim().equals("")){
				throw new Exception();
			}else{
				p.setNombre(nombre.trim());
				p.setDescripcion(descripcion.trim());
				p.setActivo(activo.trim());
				//p.setNombre((String)inNombre.getValue());
				//p.setDescripcion((String)inDescripcion.getValue());
				//p.setActivo((String)inActivo.getValue());
				ss.actualizarPerfil(p);
				setStyle(getStyleSuccess());
				setMsgUp("Perfil actualizado con xito");
				setNombre("");
				outNombre.setValue("");
				setDescripcion("");
				outDescripcion.setValue("");
				setActivo("");
			}
		}catch(Exception e){
			setStyle(getStyleError());
			setMsgUp("La operacin no fue completada");
		}
		
	}
	
	public void cargarInfoPerfil(ValueChangeEvent event){
		String nombrePerfil = (String)event.getNewValue();
		if(nombrePerfil!=null){
			Perfil p = ss.buscarPerfilPorNombre(nombrePerfil);
			inNombre.setValue(p.getNombre());
			outNombre.setValue("Actual: "+p.getNombre());
			inDescripcion.setValue(p.getDescripcion());
			outDescripcion.setValue("Actual: "+p.getDescripcion());
			inActivo.setValue(p.getActivo());
		}
	}
	
	public void cargarInicio(ActionEvent event){
		setNombre("");
		outNombre.setValue("");
		setDescripcion("");
		outDescripcion.setValue("");
	}
	
	public String getNombre() {
		return nombre;
	}
	
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	
	public String getDescripcion() {
		return descripcion;
	}
	
	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}
	
	public String getActivo() {
		return activo;
	}
	
	public void setActivo(String activo) {
		this.activo = activo;
	}
	
	public UIInput getInNombre() {
		return inNombre;
	}

	public void setInNombre(UIInput inNombre) {
		this.inNombre = inNombre;
	}

	public HtmlOutputText getOutNombre() {
		return outNombre;
	}

	public void setOutNombre(HtmlOutputText outNombre) {
		this.outNombre = outNombre;
	}

	public UIInput getInDescripcion() {
		return inDescripcion;
	}

	public void setInDescripcion(UIInput inDescripcion) {
		this.inDescripcion = inDescripcion;
	}

	public HtmlOutputText getOutDescripcion() {
		return outDescripcion;
	}

	public void setOutDescripcion(HtmlOutputText outDescripcion) {
		this.outDescripcion = outDescripcion;
	}

	public HtmlSelectOneRadio getInActivo() {
		return inActivo;
	}

	public void setInActivo(HtmlSelectOneRadio inActivo) {
		this.inActivo = inActivo;
	}

	public void setListaPerfil(List<SelectItem> listaPerfil) {
		this.listaPerfil = listaPerfil;
	}



	public void setPerfilesObjetos(List<Perfil> perfilesObjetos) {
		this.perfilesObjetos = perfilesObjetos;
	}

	public void setStyle(String style) {
		this.style = style;
	}

	public String getStyle() {
		return style;
	}

	public void setStyleSuccess(String styleSuccess) {
		this.styleSuccess = styleSuccess;
	}

	public String getStyleSuccess() {
		return styleSuccess;
	}

	public void setStyleError(String styleError) {
		this.styleError = styleError;
	}

	public String getStyleError() {
		return styleError;
	}

	public void setMsgAdd(String msgAdd) {
		this.msgAdd = msgAdd;
	}

	public String getMsgAdd() {
		return msgAdd;
	}

	public void setMsgUp(String msgUp) {
		this.msgUp = msgUp;
	}

	public String getMsgUp() {
		return msgUp;
	}





	

}
