package ec.edu.epn.seguridad.VO;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.List;

//import javax.ejb.EJB;
//import javax.faces.application.Application;
import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.component.html.HtmlOutputText;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.faces.validator.ValidatorException;
import javax.naming.InitialContext;
import javax.servlet.http.HttpServletRequest;

import ec.edu.epn.seguridad.servicio.ServicioSeguridad;
import ec.edu.epn.seguridad.vo.Personal;
import ec.edu.epn.seguridad.vo.Unidad;
import ec.edu.epn.seguridad.vo.Usuario;

public class GestionUsuario implements Serializable{
	
	private static final long serialVersionUID = -4706493107016051445L;
	private ServicioSeguridad ss;
	{
		try {
			InitialContext ctx = new InitialContext();
			ss = (ServicioSeguridad) ctx.lookup("java:global/ServiciosSeguridadEPN/ServicioSeguridadBean!ec.edu.epn.seguridad.servicio.ServicioSeguridad");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	///Ingreso de nuevos Usuarios
	private String nombre;
	private String clave;
	private String cedula;
	private String personalIn;
	private String unidadIn;
	private List<SelectItem> listaPersonal;
	private List<SelectItem> listaUnidad;
	
	///Actualizacin de Usuarios
	private List<SelectItem> listaUsuarios;
	private UIInput nombreIn;
	private HtmlOutputText nombreOut;
	private UIInput claveIn;
	private HtmlOutputText claveOut;
	private UIInput cedulaIn;
	private HtmlOutputText cedulaOut;
	private UIInput personalIN;
	private HtmlOutputText personalOut;
	private UIInput unidadIN;
	private HtmlOutputText unidadOut;
	
	///Listado de Usuarios
	private List<UsuarioTemp> listaUsuariosObjetos;
	
	//Estilos para los mensajes de Error
	private String style;
	private String styleSuccess="COLOR: #008000;";
	private String styleError="COLOR: #fc5868;";
	private String msgAdd;
	private String msgUp;
	
	public List<SelectItem> getListaPersonal() {
		
		listaPersonal = new ArrayList<SelectItem>();
		
		List<Personal> buscarPersonal = ss.getListaPersonal();
		Collections.sort(buscarPersonal, new ComparatorAdmin());
		for(Personal per : buscarPersonal){
			SelectItem item = new SelectItem(per.getNombresPe(),per.getNombresPe());
			listaPersonal.add(item);
		}
		
		return listaPersonal;
	}
	
	public List<SelectItem> getListaUnidad() {
		
		listaUnidad = new ArrayList<SelectItem>();
		
		List<Unidad> buscarUnidades = ss.getListaUnidades();
		Collections.sort(buscarUnidades, new ComparatorAdmin());
		for(Unidad u : buscarUnidades){
			SelectItem item = new SelectItem(u.getNombreU(),u.getNombreU());
			listaUnidad.add(item);
		}
		
		return listaUnidad;
	}
	
	public List<SelectItem> getListaUsuarios() {
		
		listaUsuarios = new ArrayList<SelectItem>();
		
		List<Usuario> buscarUsuarios = ss.getListaUsuarios();
		Collections.sort(buscarUsuarios, new ComparatorAdmin());
		for(Usuario u : buscarUsuarios){
			SelectItem item = new SelectItem(u.getNombreUsuario(),u.getNombreUsuario());
			listaUsuarios.add(item);
		}
		
		return listaUsuarios;
	}
	
	public void guardarUsuario(ActionEvent event){
		Usuario user = new Usuario();
		
		try{
			if(nombre.trim().equals("") || clave.trim().equals("") || cedula.trim().equals("")
					 || personalIn.trim().equals("") || unidadIn.trim().equals("")){
				throw new Exception();
			}else{
				Validadores val = new Validadores();
				if(val.isCedula(cedula.trim())){
					user.setCedula(cedula.trim());
				}else{
					throw new NumberFormatException();
				}
				user.setNombreUsuario(nombre.trim());
				user.setClave(!clave.trim().equals("") ? clave.trim() : "epn.edu.ec");
				user.setFechaCreacion(new Date());
				user.setIdPersonal(getIdPersonal());
				user.setId_unidad(getIdUnidad());
				ss.guardarUsuario(user);
				setStyle(getStyleSuccess());
				setMsgAdd("Usuario ingresado con xito");
				setNombre("");
				setClave("");
				setCedula("");
				setPersonalIn("");
				setUnidadIn("");
			}
		}catch(Exception e){
			setStyle(getStyleError());			
			if(e.getClass().getName().equals(NumberFormatException.class.getName())){
				setMsgAdd("Valor de cdula errneo");
			}else{
				setMsgAdd("La operacin no fue completada");
			}	
		}
	}
	
	public void validarCedula(FacesContext context, UIComponent component,
			Object value) throws ValidatorException{
		String numCedula = (String)value;
		Validadores val = new Validadores();
		if(!val.isCedula(numCedula)){
			throw new ValidatorException(new FacesMessage(
					FacesMessage.SEVERITY_ERROR, "La cdula debe contener solo nmeros",
					"El nmero de cdula "+numCedula+" es invlido"
					)); 
		}
		
	}
	
	
	public void cargarDatosUsuario(ValueChangeEvent event){
		String nombreUsuario = (String)event.getNewValue();
		if(nombreUsuario!=null){
			try{
				Usuario user = ss.buscarUsuarioPorNombre(nombreUsuario);
				nombreIn.setValue(user.getNombreUsuario());
				nombreOut.setValue("Actual: "+user.getNombreUsuario());
				claveIn.setValue(user.getClave());
				claveOut.setValue("Actual: "+user.getClave());
				cedulaIn.setValue(user.getCedula());
				cedulaOut.setValue("Actual: "+user.getCedula());
				personalIN.setValue(getNombrePersonal(user.getIdPersonal()));
				personalOut.setValue("Actual: "+getNombrePersonal(user.getIdPersonal()));
				unidadIN.setValue(getNombreUnidad(user.getId_unidad()));
				unidadOut.setValue("Actual: "+getNombreUnidad(user.getId_unidad()));
			}catch(Exception e){				
				System.out.println("Usuario no encontrado");
			}
			
		}
		
	}
	
	public void actualizarUsuario(ActionEvent event){
		FacesContext fc = FacesContext.getCurrentInstance();
		HttpServletRequest request = (HttpServletRequest) fc
			.getExternalContext().getRequest();
		String usuarioSeleccionado = request.getParameter("formActualizarUsuario:seleccionUsuario");
		try{
			if(nombre.trim().equals("") || clave.trim().equals("") || cedula.trim().equals("")
					 || personalIn.trim().equals("") || unidadIn.trim().equals("")){
				throw new Exception();
			}else{
				Usuario user = ss.buscarUsuarioPorNombre(usuarioSeleccionado);	
				Validadores val = new Validadores();
				if(val.isCedula(cedula.trim())){
					user.setCedula(cedula.trim());
				}else{					
					throw new NumberFormatException();
				}
			user.setNombreUsuario(!nombre.trim().equals("") ? nombre.trim() : user.getNombreUsuario());
			user.setClave(!clave.trim().equals("") ? clave.trim() : "epn.edu.ec");
			user.setId_unidad(getIdUnidad());
			user.setIdPersonal(getIdPersonal());
			ss.actualizarUsuario(user);
			setStyle(getStyleSuccess());
			setMsgUp("Usuario actualizado con xito");
			setNombre(" ");
			setClave(" ");
			setCedula(" ");
			setPersonalIn(" ");
			setUnidadIn(" ");
			}
		}catch(Exception e){
			setStyle(getStyleError());
			if(e.getClass().getName().equals(NumberFormatException.class.getName())){
				setMsgUp("Valor de cdula errneo");
			}else{
				setMsgUp("La operacin no fue completada");
			}
		}
		
	}
	
	public List<UsuarioTemp> getListaUsuariosObjetos() {
		
		listaUsuariosObjetos = new ArrayList<UsuarioTemp>();
		
		List<Usuario> users = new ArrayList<Usuario>();
		
		users = ss.getListaUsuarios();
		Collections.sort(users, new ComparatorAdmin());
		
		for(Usuario user : users){
			UsuarioTemp userTemp = new UsuarioTemp();
			userTemp.setId(user.getId());
			userTemp.setNombreUsuario(user.getNombreUsuario());
			userTemp.setClave(user.getClave());
			userTemp.setCedula(user.getCedula());
			userTemp.setFechaCreacion(user.getFechaCreacion());
			
			Personal per = new Personal();
			per = ss.buscarPersonalPorID(user.getIdPersonal());
			
			Unidad uni = new Unidad();
			uni = ss.buscarUnidadPorID(user.getId_unidad());
			
			userTemp.setPersonal(per);
			userTemp.setUnidad(uni);
			
			listaUsuariosObjetos.add(userTemp);
		}
		
		return listaUsuariosObjetos;
	}
	
	private int getIdUnidad() {
		return ss.buscarUnidadPorNombre(unidadIn).getIdUnidad();
	}

	private String getIdPersonal() {
		return ss.buscarPersonalPorNombre(personalIn).getIdPersonal();
	}
	
	public String getNombrePersonal(String personalId){
		List<Personal> buscarPersonal = ss.getListaPersonal();
		for(Personal p: buscarPersonal){
			if(p.getIdPersonal().equals(personalId)){
				return p.getNombresPe();
			}
		}
		return " ";
	}
	
	public String getNombreUnidad(int unidadId){
		List<Unidad> buscarUnidades = ss.getListaUnidades();
		for(Unidad u : buscarUnidades){
			if(u.getIdUnidad()==unidadId){
				return u.getNombreU();
			}
		}
		return " ";
	}
	
    public void cargarInicio(ActionEvent event){
		nombreIn.setValue(" ");
		claveIn.setValue(" ");
		cedulaIn.setValue(" ");
		personalIN.setValue(" ");
		unidadIN.setValue(" ");
		nombreOut.setValue("");
		claveOut.setValue("");
		cedulaOut.setValue("");
		personalOut.setValue("");
		unidadOut.setValue("");
	}

    
	public String getNombre() {
		return nombre;
	}
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	public String getClave() {
		return clave;
	}
	public void setClave(String clave) {
		this.clave = clave;
	}
	public String getCedula() {
		return cedula;
	}
	public void setCedula(String cedula) {
		this.cedula = cedula;
	}
	public String getPersonalIn() {
		return personalIn;
	}
	public void setPersonalIn(String personalIn) {
		this.personalIn = personalIn;
	}
	public String getUnidadIn() {
		return unidadIn;
	}
	public void setUnidadIn(String unidadIn) {
		this.unidadIn = unidadIn;
	}
	
	public void setListaPersonal(List<SelectItem> listaPersonal) {
		this.listaPersonal = listaPersonal;
	}
	
	public void setListaUnidad(List<SelectItem> listaUnidad) {
		this.listaUnidad = listaUnidad;
	}


	public void setListaUsuarios(List<SelectItem> listaUsuarios) {
		this.listaUsuarios = listaUsuarios;
	}

	public UIInput getNombreIn() {
		return nombreIn;
	}

	public void setNombreIn(UIInput nombreIn) {
		this.nombreIn = nombreIn;
	}

	public HtmlOutputText getNombreOut() {
		return nombreOut;
	}

	public void setNombreOut(HtmlOutputText nombreOut) {
		this.nombreOut = nombreOut;
	}

	public UIInput getClaveIn() {
		return claveIn;
	}

	public void setClaveIn(UIInput claveIn) {
		this.claveIn = claveIn;
	}

	public HtmlOutputText getClaveOut() {
		return claveOut;
	}

	public void setClaveOut(HtmlOutputText claveOut) {
		this.claveOut = claveOut;
	}

	public UIInput getCedulaIn() {
		return cedulaIn;
	}

	public void setCedulaIn(UIInput cedulaIn) {
		this.cedulaIn = cedulaIn;
	}

	public HtmlOutputText getCedulaOut() {
		return cedulaOut;
	}

	public void setCedulaOut(HtmlOutputText cedulaOut) {
		this.cedulaOut = cedulaOut;
	}

	public UIInput getPersonalIN() {
		return personalIN;
	}

	public void setPersonalIN(UIInput personalIN) {
		this.personalIN = personalIN;
	}

	public HtmlOutputText getPersonalOut() {
		return personalOut;
	}

	public void setPersonalOut(HtmlOutputText personalOut) {
		this.personalOut = personalOut;
	}

	public UIInput getUnidadIN() {
		return unidadIN;
	}

	public void setUnidadIN(UIInput unidadIN) {
		this.unidadIN = unidadIN;
	}

	public HtmlOutputText getUnidadOut() {
		return unidadOut;
	}

	public void setUnidadOut(HtmlOutputText unidadOut) {
		this.unidadOut = unidadOut;
	}

	public void setListaUsuariosObjetos(List<UsuarioTemp> listaUsuariosObjetos) {
		this.listaUsuariosObjetos = listaUsuariosObjetos;
	}

	public void setStyle(String style) {
		this.style = style;
	}

	public String getStyle() {
		return style;
	}

	public void setStyleSuccess(String styleSuccess) {
		this.styleSuccess = styleSuccess;
	}

	public String getStyleSuccess() {
		return styleSuccess;
	}

	public void setStyleError(String styleError) {
		this.styleError = styleError;
	}

	public String getStyleError() {
		return styleError;
	}

	public void setMsgAdd(String msgAdd) {
		this.msgAdd = msgAdd;
	}

	public String getMsgAdd() {
		return msgAdd;
	}

	public void setMsgUp(String msgUp) {
		this.msgUp = msgUp;
	}

	public String getMsgUp() {
		return msgUp;
	}

	

}
