package ec.edu.epn.seguridad.VO;

import java.io.Serializable;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Validadores implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -817588918225390437L;

	private String sucesos = " ";
	
	public static final int NUMERO_DE_PROVINCIAS = 24; 
		
	public boolean isNumeric(String entrada){
        Pattern patron = Pattern.compile("[^0-9]");
        Matcher encaja = patron.matcher(entrada);
        setSucesos("");
        try {
        	if(!encaja.find()){        		
                return true;
            }
            else{
            	this.setSucesos("No es un numero");                
                return false;
            }
        }catch (NumberFormatException nfe){			
			return false;
	    }
    }
	
	public boolean isString(String entrada){
        Pattern patron = Pattern.compile("[^a-zA-Z        .]");
        Matcher encaja = patron.matcher(entrada);
        setSucesos("");
        try{
        	if(!encaja.find()){                
                return true;
            }
            else{
            	this.setSucesos("No es una cadena de caracteres");                
                return false;
            }
        }catch (Exception e) {        	
			return false;
		}
        
    }
	
	public boolean isCedula(String entrada){
        Pattern patron = Pattern.compile("[^0-9]");
        Matcher encaja = patron.matcher(entrada);
        int prov = Integer.parseInt(entrada.substring(0,2));
        setSucesos("");
        try {
        	if(!encaja.find()){
            	if (entrada.length() < 10) {
            		this.setSucesos("Cdula incompleta");    				
    				return false;
            	}else if(entrada.length() > 10){
    				this.setSucesos("Cdula incorrecta");    				
    				return false;
    			}else if(!((prov > 0) && (prov <= NUMERO_DE_PROVINCIAS))) {
            			this.setSucesos("Cdula incorrecta");            			
            			return false;
    			}                
                return true;
            }
            else{
            	this.setSucesos("No es una cedula");                
                return false;
            }
        }catch (NumberFormatException nfe){			
			return false;
	    }
    }
	
	public boolean isRuc(String entrada){
        Pattern patron = Pattern.compile("[^0-9]");
        Matcher encaja = patron.matcher(entrada);
        setSucesos("");
        
        try{
        	if(!encaja.find()){
            	if (entrada.length() != 13) {
            		this.setSucesos("Ruc incompleto");    				
    				return false;
            	}else            		
                	return true;
            }
            else{
            	this.setSucesos("No es RUC");                
                return false;
            }
        }catch (Exception e) {
        	this.setSucesos("No es RUC");        	
			return false;
		}
    }
	
	public boolean isMail(String entrada){
        Pattern patron = Pattern.compile("^([a-zA-Z0-9_\\-\\.]+)*[a-zA-Z0-9]@[a-zA-Z]*" +
        		"[a-zA-Z0-9].[a-zA-Z][a-zA-Z\\.]*[a-zA-Z]$");
        Matcher encaja = patron.matcher(entrada);
        setSucesos("");
        
        try {
        	if(!encaja.find()){                
                return true;
            }
            else{
            	this.setSucesos("No es un mail");                
                return false;
            }
		} catch (Exception e) {			
			return false;
		}
        
    }
	
	public boolean isFono(String entrada){		
		Pattern patron = Pattern.compile("[^0-9]");
		Matcher encaja = patron.matcher(entrada);
		setSucesos("");
		
		try {
			if(!encaja.find()){				
				if (entrada.length() < 7 ) {
					this.setSucesos("Telfono incompleto");					
					return false;
					}else
						return true;
			}else{
				this.setSucesos("No es un nmero vlido");				
				return false;
			}
		} catch (Exception e) {			
			return false;
		}
    }
	
	
	public String getSucesos() {
		return sucesos;
	}

	public void setSucesos(String sucesos) {
		this.sucesos = sucesos;
	}
	
	
}
