package ec.edu.epn.seguridad.filtro;

import java.io.IOException;
import java.io.Serializable;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.naming.InitialContext;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import ec.edu.epn.seguridad.VO.SesionUsuario;
import ec.edu.epn.seguridad.servicio.ServicioSeguridad;

public class FiltroAuditoria implements Filter, Serializable {
	
	private static final long serialVersionUID = -657388017221155722L;

	private FilterConfig filterConfig;
	
	@SuppressWarnings("unused")
	private ServicioSeguridad ss;
	{
		try {
			InitialContext ctx = new InitialContext();
			ss = (ServicioSeguridad) ctx
					.lookup("java:global/ServiciosSeguridadEPN/ServicioSeguridadBean!ec.edu.epn.seguridad.servicio.ServicioSeguridad");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@SuppressWarnings("unused")
	public void doFilter(ServletRequest req, ServletResponse resp,
			FilterChain chain) throws IOException, ServletException {
		HttpServletRequest request = (HttpServletRequest) req;
		HttpServletResponse response = (HttpServletResponse) resp;
		HttpSession session = request.getSession();
		Hashtable<String, String> urlNoControladas = new Hashtable<String, String>();
		urlNoControladas.put("/seguridad/seleccionRol.jsf", "URL seteo roles");
		urlNoControladas.put("/seguridad/cambioClave.jsf","URL cambio de clave");
		urlNoControladas.put("/seguridad/noAutorizado.jsf", "URL no autorizado");

		if (!urlNoControladas.containsKey(request.getServletPath())) {
			SesionUsuario su = (SesionUsuario) session
					.getAttribute("sesionUsuario");			
			Enumeration<String> nombreParametros = request.getParameterNames();			
			while (nombreParametros.hasMoreElements()) {
				String nombreParametro = nombreParametros.nextElement();
				if (!nombreParametro.equals("javax.faces.ViewState")) {
					String valor = request.getParameter(nombreParametro);
					if (valor.length() > 200) {
						valor = valor.substring(0, 200);
					}
				}
			}		}
		chain.doFilter(request, response);
	}

	public void init(FilterConfig filterConfig) throws ServletException {
		this.filterConfig = filterConfig;
	}

	public void destroy() {
	}

	public FilterConfig getFilterConfig() {
		return filterConfig;
	}

	public void setFilterConfig(FilterConfig filterConfig) {
		this.filterConfig = filterConfig;
	}
}
