package ec.edu.epn.seguridad.filtro;

import java.io.IOException;
import java.io.Serializable;
import java.util.Hashtable;
import java.util.Map;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import javax.faces.application.ResourceHandler;

import ec.edu.epn.seguridad.VO.SesionUsuario;

public class FiltroAutorizacion implements Filter, Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -4266992020481797282L;
	/**
	 * 
	 */
	
	private FilterConfig filterConfig;
	
	public void doFilter(ServletRequest req, ServletResponse resp,
			FilterChain chain) throws IOException, ServletException {
		HttpServletRequest request = (HttpServletRequest) req;
		HttpServletResponse response = (HttpServletResponse) resp;
		HttpSession session = request.getSession();
		Hashtable<String,String> urlNoControladas = new Hashtable<String,String>();
		urlNoControladas.put("/seguridad/seleccionRol.jsf", "URL seteo roles");
		urlNoControladas.put("/seguridad/cambioClave.jsf", "URL cambio de clave");
		urlNoControladas.put("/seguridad/noAutorizado.jsf", "URL no autorizado");
		urlNoControladas.put("/seguridad/cerrarSesion", "URL cierre sesion");
		
		String uri = ((HttpServletRequest) request).getRequestURI();		
				
		if (urlNoControladas.containsKey(request.getServletPath())){
			chain.doFilter(request,response);
		}else{
			SesionUsuario su = (SesionUsuario) session.getAttribute("sesionUsuario");
			Map<String,String> opciones = su.getOpciones();
            if(opciones!=null && opciones.containsKey(request.getServletPath())){
            	String accesos = opciones.get(request.getServletPath());
            	request.setAttribute(SesionUsuario.NOMBRE_VARIABLE_ACCESOS,accesos);
            	chain.doFilter(request,response);
            }else if(uri.startsWith(request.getContextPath() + ResourceHandler.RESOURCE_IDENTIFIER) || uri.startsWith(request.getContextPath())){
    			    chain.doFilter(request, response);
            }else{
            	RequestDispatcher rd = request.getRequestDispatcher("/seguridad/noAutorizado.jsf");
            	rd.forward(request,response);
            }
		}
	}
	
	public void init(FilterConfig filterConfig) throws ServletException {
        this.filterConfig=filterConfig;
	}
	
	public void destroy() {
	}
	
	public FilterConfig getFilterConfig() {
		return filterConfig;
	}
}
